<template>
  <app-drawer
    v-model="isDrawerVisible"
    title="HubSpot"
    size="600px"
    pre-title="Integration"
    :show-footer="true"
    has-border
    @close="isDrawerVisible = false"
  >
    <template #beforeTitle>
      <img
        :src="hubspotDetails.image"
        class="w-6 h-6 mr-2"
        alt="HubSpot logo"
      />
    </template>
    <template #content>
      <div>
        <section class="pb-6">
          <h4 class="text-base font-semibold pb-1">
            Enable data syncing
          </h4>
          <p class="text-2xs text-gray-500">
            Define which GetSphere.dev core elements can be synced to or from HubSpot.
          </p>
        </section>
        <section>
          <article class="border border-gray-200 rounded-t py-4 px-5 flex justify-between">
            <div>
              <h5 class="text-sm font-semibold pb-1">
                Contacts
              </h5>
              <p class="text-2xs text-gray-500 leading-4.5">
                <span class="font-semibold">Data-in</span>: Existing contacts will automatically be enriched with data
                points
                from HubSpot contacts every 8 hours.
                <span class="font-semibold">Data-out</span>: To send contacts to HubSpot, use Automations or select
                contacts manually.
              </p>
            </div>
            <div>
              <el-switch v-model="form.members" @change="syncSelected($event, 'member')" />
            </div>
          </article>
          <article class="border border-gray-200 rounded-b border-t-0 py-4 px-5 flex justify-between">
            <div>
              <h5 class="text-sm font-semibold pb-1">
                Organizations
              </h5>
              <p class="text-2xs text-gray-500 leading-4.5">
                <span class="font-semibold">Data-in</span>: Existing organizations will automatically be enriched with
                data points from HubSpot companies every 8 hours.
                <span class="font-semibold">Data-out</span>: To send organizations to HubSpot, use Automations or select
                organizations manually.
              </p>
            </div>
            <div>
              <el-switch v-model="form.organizations" @change="syncSelected($event, 'organization')" />
            </div>
          </article>
        </section>
      </div>
    </template>

    <template #footer>
      <div style="flex: auto">
        <el-button
          class="btn btn--md btn--bordered mr-3"
          @click="isDrawerVisible = false"
        >
          Cancel
        </el-button>
        <el-button
          type="primary"
          class="btn btn--md btn--primary"
          :disabled="loading"
          :loading="loading"
          @click="update()"
        >
          Update
        </el-button>
      </div>
    </template>
  </app-drawer>
  <app-hubspot-read-only-attr-popover
    v-model="isReadOnlyConfirmModalVisible"
    :attributes="readOnlyAttributes"
    @update:model-value="isReadOnlyConfirmModalVisible = $event"
    @do-not-show-modal="handleDoNotShowModal"
    @continue="handleContinue"
  />
</template>

<script lang="ts" setup>
import {
  computed, onMounted, reactive, ref, defineProps,
} from 'vue';
import { useStore } from 'vuex';
import { CrowdIntegrations } from '@/integrations/integrations-config';
import { HubspotApiService } from '@/integrations/hubspot/hubspot.api.service';
import { HubspotOnboard } from '@/integrations/hubspot/types/HubspotOnboard';
import { HubspotEntity } from '@/integrations/hubspot/types/HubspotEntity';
import { mapActions } from '@/shared/vuex/vuex.helpers';
import AppHubspotReadOnlyAttrPopover from '@/integrations/hubspot/components/hubspot-readonly-attr-popover.vue';

const props = defineProps<{
  modelValue: boolean,
  integration: any,
}>();

const emit = defineEmits<{(e: 'update:modelValue', value: boolean): void }>();

const store = useStore();
const { doFetch } = mapActions('integration');

const activeView = ref<string | null>(null);
const isDrawerVisible = computed({
  get() {
    return props.modelValue;
  },
  set(val) {
    emit('update:modelValue', val);
  },
});

const isReadOnlyConfirmModalVisible = ref<boolean>(false);
const readOnlyAttributes = ref<string[]>([]);

// updateData is a new reference of "data" object used in update() method
const updateData = ref<HubspotOnboard | null>(null);

const form = reactive({
  members: false,
  organizations: false,
  enabled: {
    members: {},
    organizations: {},
  },
  mapping: {
    members: {},
    organizations: {},
  },
});

const loading = ref<boolean>(false);

const hubspotDetails = computed(() => CrowdIntegrations.getConfig('hubspot'));

const syncSelected = (value: boolean, attribute: string) => {
  if (value) {
    activeView.value = attribute;
  } else if (activeView.value === attribute) {
    activeView.value = null;
  }
};

// save read only confirm modal to false in local storage
const handleDoNotShowModal = () => {
  localStorage.setItem('show_hubspot_read_only_confirm_modal', 'false');
};

// hide modal and execute update
const handleContinue = () => {
  isReadOnlyConfirmModalVisible.value = false;
  executeUpdate(updateData.value!);
};

const update = () => {
  const data: HubspotOnboard = {
    enabledFor: [
      ...(form.members ? [HubspotEntity.MEMBERS] : []),
      ...(form.organizations ? [HubspotEntity.ORGANIZATIONS] : []),
    ],
    attributesMapping: {
      members: {},
      organizations: {},
    },
  };
  executeUpdate(data);
};

const executeUpdate = (data: HubspotOnboard) => {
  loading.value = true;
  HubspotApiService.finishOnboard(data)
    .then(() => {
      doFetch(null);
      isDrawerVisible.value = false;
    })
    .finally(() => {
      loading.value = false;
    });
};

const fillForm = (data: HubspotOnboard) => {
  form.members = data.enabledFor.includes(HubspotEntity.MEMBERS);
  form.organizations = data.enabledFor.includes(HubspotEntity.ORGANIZATIONS);
};

onMounted(() => {
  const data = CrowdIntegrations.getMappedConfig('hubspot', store);
  fillForm(data.settings);
});

</script>

<script lang="ts">
export default {
  name: 'AppHubspotSettingsDrawer',
};
</script>

<style lang="scss">
.el-collapse.attributes {
  @apply border-0;
}

.el-collapse-item {
  .el-collapse-item__header {
    @apply h-14 border-0;
  }

  &:not(:last-child) {
    @apply border-b border-gray-100;
  }

  .el-collapse-item__arrow {
    @apply hidden;
  }
}

.el-select.map-attribute {
  .el-input {
    @apply min-h-8 bg-gray-50;

    .el-input__wrapper {
      @apply bg-gray-50;
    }

    .el-input__suffix-inner {
      top: 0.5rem;
    }
  }
}

.c-select {
  @apply w-full h-8 bg-gray-50 border border-gray-100 rounded-md px-2 text-2xs text-gray-600;
}
</style>
